/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: Rotation.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 00:45:56 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _CHART2_TOOLS_ROTATION_HXX
#define _CHART2_TOOLS_ROTATION_HXX


// header for class Matrix4D
#ifndef _B3D_HMATRIX_HXX
#include <goodies/hmatrix.hxx>
#endif

#ifndef _COM_SUN_STAR_DRAWING_DIRECTION3D_HPP_
#include <com/sun/star/drawing/Direction3D.hpp>
#endif

//.............................................................................
namespace chart
{
//.............................................................................

//-----------------------------------------------------------------------------
/**
*/

class Rotation
{
    public:
        static Matrix4D getRotationMatrixFromAxisAngleRepresentation( const ::com::sun::star::drawing::Direction3D& rAxis, double fAngleDegree );
        static void getRotationAxisAngleFromMatrixRepresentation( ::com::sun::star::drawing::Direction3D& rAxis, double& fAngleDegree, const Matrix4D& rMatrix );
        static void getEulerFromAxisAngleRepresentation( const ::com::sun::star::drawing::Direction3D& rAxis, double fAngleDegree, double& fXAngle, double& fYAngle, double& fZAngle  );
        static void getAxisAngleFromEulerRepresentation( ::com::sun::star::drawing::Direction3D& rAxis, double& fAngleDegree, double fXAngle, double fYAngle, double fZAngle );
};

//.............................................................................
} //namespace chart
//.............................................................................
#endif
