#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.25 $
#
#   last change: $Author: rt $ $Date: 2005/09/08 03:38:29 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

PRJ=..$/..
PRJINC=$(PRJ)$/source$/inc
PRJNAME=
TARGET=cppugen

# --- Settings ----------------------------------

.INCLUDE : settings.mk

# --- Types -------------------------------------



# --- Types -------------------------------------

UNOTYPES+=	\
		com.sun.star.uno.XAggregation					\
		com.sun.star.uno.XCurrentContext				\
		com.sun.star.uno.XWeak							\
		com.sun.star.uno.TypeClass						\
		com.sun.star.beans.XExactName					\
		com.sun.star.beans.XHierarchicalPropertySet		\
		com.sun.star.beans.XFastPropertySet				\
		com.sun.star.beans.XMultiHierarchicalPropertySet \
		com.sun.star.beans.XMultiPropertySet			\
		com.sun.star.beans.XProperty					\
		com.sun.star.beans.XPropertyWithState			\
		com.sun.star.beans.XPropertyState				\
		com.sun.star.beans.XMultiPropertyStates			\
		com.sun.star.beans.XPropertySet					\
		com.sun.star.beans.PropertyValue				\
		com.sun.star.beans.Property						\
		com.sun.star.beans.PropertyAttribute			\
		com.sun.star.beans.IllegalTypeException			\
		com.sun.star.beans.PropertyExistException		\
		com.sun.star.configuration.XTemplateContainer	\
		com.sun.star.configuration.XTemplateInstance	\
		com.sun.star.configuration.backend.TemplateIdentifier	\
		com.sun.star.configuration.backend.SchemaAttribute		\
		com.sun.star.configuration.backend.NodeAttribute		\
		com.sun.star.configuration.backend.XSchemaHandler		\
		com.sun.star.configuration.backend.XLayerHandler		\
		com.sun.star.configuration.backend.XUpdateHandler		\
		com.sun.star.configuration.backend.XUpdatableLayer		\
		com.sun.star.configuration.backend.XCompositeLayer		\
		com.sun.star.configuration.backend.XLayerImporter		\
		com.sun.star.configuration.backend.XBackend				\
		com.sun.star.configuration.backend.XBackendEntities		\
		com.sun.star.configuration.backend.XSchemaSupplier		\
		com.sun.star.configuration.backend.XVersionedSchemaSupplier		\
		com.sun.star.configuration.backend.XSingleLayerStratum	\
		com.sun.star.configuration.backend.XMultiLayerStratum	\
		com.sun.star.configuration.backend.XSchema				\
		com.sun.star.configuration.backend.XLayer				\
		com.sun.star.configuration.backend.MergeRecoveryRequest		\
		com.sun.star.configuration.backend.MalformedDataException	\
		com.sun.star.configuration.backend.BackendAccessException	\
        com.sun.star.configuration.backend.BackendSetupException	\
        com.sun.star.configuration.backend.StratumCreationException	\
        com.sun.star.configuration.backend.AuthenticationFailedException \
        com.sun.star.configuration.backend.InvalidAuthenticationMechanismException   \
        com.sun.star.configuration.backend.CannotConnectException	\
        com.sun.star.configuration.backend.ConnectionLostException	\
        com.sun.star.configuration.backend.InsufficientAccessRightsException \
		com.sun.star.configuration.backend.ComponentChangeEvent		\
		com.sun.star.configuration.backend.XBackendChangesListener	\
		com.sun.star.configuration.backend.XBackendChangesNotifier	\
	    com.sun.star.configuration.backend.PropertyInfo				\
	    com.sun.star.configuration.backend.XLayerContentDescriber	\
        com.sun.star.configuration.MissingBootstrapFileException	\
		com.sun.star.configuration.InvalidBootstrapFileException	\
		com.sun.star.configuration.InstallationIncompleteException	\
		com.sun.star.container.XNamed					\
		com.sun.star.container.XHierarchicalName		\
		com.sun.star.container.XChild					\
		com.sun.star.container.XNameAccess				\
		com.sun.star.container.XNameReplace				\
		com.sun.star.container.XNameContainer			\
		com.sun.star.container.XHierarchicalNameAccess	\
		com.sun.star.container.XElementAccess			\
		com.sun.star.container.XContainer				\
		com.sun.star.container.NoSuchElementException	\
		com.sun.star.io.XActiveDataSink					\
		com.sun.star.io.XActiveDataSource				\
		com.sun.star.io.XInputStream					\
		com.sun.star.io.XOutputStream					\
		com.sun.star.io.XDataInputStream				\
		com.sun.star.io.XDataOutputStream				\
		com.sun.star.io.UnexpectedEOFException			\
		com.sun.star.io.WrongFormatException			\
		com.sun.star.lang.XComponent					\
		com.sun.star.lang.XEventListener				\
		com.sun.star.lang.XInitialization				\
		com.sun.star.lang.XLocalizable					\
		com.sun.star.lang.XMultiComponentFactory		\
		com.sun.star.lang.XMultiServiceFactory			\
		com.sun.star.lang.XSingleComponentFactory		\
		com.sun.star.lang.XSingleServiceFactory			\
		com.sun.star.lang.XServiceInfo					\
		com.sun.star.lang.XTypeProvider					\
		com.sun.star.lang.XUnoTunnel					\
		com.sun.star.lang.EventObject					\
		com.sun.star.lang.ServiceNotRegisteredException	\
		com.sun.star.lang.IllegalArgumentException		\
		com.sun.star.lang.WrappedTargetException		\
		com.sun.star.lang.WrappedTargetRuntimeException	\
		com.sun.star.lang.DisposedException				\
		com.sun.star.registry.XRegistryKey				\
		com.sun.star.registry.XSimpleRegistry			\
		com.sun.star.script.XTypeConverter				\
		com.sun.star.script.FailReason					\
		com.sun.star.task.XJob							\
		com.sun.star.task.XInteractionHandler			\
		com.sun.star.task.XInteractionRequest			\
		com.sun.star.task.XInteractionContinuation		\
		com.sun.star.task.XInteractionApprove			\
		com.sun.star.task.XInteractionDisapprove		\
		com.sun.star.task.XInteractionAbort				\
		com.sun.star.task.XInteractionRetry				\
		com.sun.star.util.XCancellable					\
		com.sun.star.util.XChangesBatch					\
		com.sun.star.util.XChangesListener				\
		com.sun.star.util.XChangesNotifier				\
		com.sun.star.util.XFlushable					\
		com.sun.star.util.XStringEscape					\
		com.sun.star.util.XTimeStamped					\
		com.sun.star.util.Date							\
		com.sun.star.util.Time							\
		com.sun.star.util.DateTime						\
		com.sun.star.util.XRefreshable                  \
		com.sun.star.util.XFlushable                    \
		com.sun.star.util.logging.XLogger               \
		com.sun.star.util.logging.LogLevel              \
		com.sun.star.xml.sax.XAttributeList				\
		com.sun.star.xml.sax.XDocumentHandler			\
		com.sun.star.xml.sax.XExtendedDocumentHandler	\
		com.sun.star.xml.sax.XParser					\
		com.sun.star.xml.sax.SAXParseException

# --- Targets ----------------------------------

.INCLUDE : target.mk

