#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.14 $
#
#   last change: $Author: rt $ $Date: 2005/09/08 17:44:43 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

PRJ = ..$/..

PRJNAME = desktop
TARGET = unopkg
TARGETTYPE = CUI
ENABLE_EXCEPTIONS = TRUE
NO_BSYMBOLIC = TRUE

PRJINC += ..$/deployment
.INCLUDE : settings.mk

.IF "$(SYSTEM_DB)" == "YES"
CFLAGS+=-DSYSTEM_DB -I$(DB_INCLUDES)
.ENDIF

# INCPRE += ..$/deployment$/inc

SHARED_OBJS = \
        $(OBJ)$/unopkg_misc.obj \
        $(OBJ)$/unopkg_cmdenv.obj

#################################################################

MYAPP1OBJS = \
        $(SHARED_OBJS) \
        $(OBJ)$/unopkg_app.obj
APP1OBJS = \
        $(MYAPP1OBJS) \
        $(OBJ)$/lockfile.obj \
        $(SLO)$/dp_misc.obj

APP1STDLIBS = \
        $(SALLIB) \
        $(CPPULIB) \
        $(CPPUHELPERLIB) \
        $(COMPHELPERLIB) \
        $(UCBHELPERLIB) \
        $(UNOTOOLSLIB) \
        $(TOOLSLIB)

APP1TARGET = unopkg

#################################################################

MYAPP2OBJS = \
        $(SHARED_OBJS) \
        $(OBJ)$/pkgchk_balancing.obj \
        $(OBJ)$/pkgchk_app.obj
APP2OBJS = \
        $(MYAPP2OBJS) \
        $(OBJ)$/lockfile.obj \
		$(SLO)$/db.obj          \
        $(SLO)$/dp_misc.obj

APP2STDLIBS = \
        $(APP1STDLIBS) \
        $(BERKELEYLIB)
#        $(BERKELEYCPPLIB)

APP2TARGET = pkgchk

#################################################################

DEPOBJFILES = $(MYAPP1OBJS) $(MYAPP2OBJS)

.IF "$(debug)" != ""

# disable MSVC inlining for debugging
.IF "$(COM)" == "MSC"
CFLAGS += -Ob0
.ENDIF

.ENDIF

.INCLUDE : target.mk

