/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: documentlist.hxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 00:29:44 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef __FRAMEWORK_DOCUMENTLIST_HXX_
#define __FRAMEWORK_DOCUMENTLIST_HXX_

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif

#include <vcl/wrkwin.hxx>
#include <rtl/ustring.hxx>

namespace framework
{
    class ModifiedDocumentsWindow_Impl;
    class ModifiedDocumentsWindow : public WorkWindow
    {
        ModifiedDocumentsWindow_Impl* pImp;

        virtual void    Resize();
        virtual void    Resizing( Size& );
        virtual BOOL    Close();

		// #110897#
		// ModifiedDocumentsWindow();
        ModifiedDocumentsWindow(
			const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& xServiceFactory
			);

		~ModifiedDocumentsWindow();

	public:

		// #110897#
        // static  ModifiedDocumentsWindow* Get();
        static  ModifiedDocumentsWindow* Get(
			const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& xServiceFactory
			);

		// #110897#
		// static  void Remove();
		static  void Remove(
			const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& xServiceFactory
			);

		static  BOOL Is();

        BOOL TryToLoad( const ::rtl::OUString& rURL,
                            const ::com::sun::star::uno::Sequence < ::com::sun::star::beans::PropertyValue >& rArgs,
                            const ::com::sun::star::uno::Reference < ::com::sun::star::frame::XFrame >& rTarget );

		// #110897#
		static  void CheckForAdding( 
			const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& xServiceFactory,
			::com::sun::star::uno::Reference < ::com::sun::star::frame::XFrame >& rFrame );

		void    AddDocument( const ::rtl::OUString&, const ::rtl::OUString& rFilterName, const ::rtl::OUString& rTitle );
        void    RemoveDocument( const ::rtl::OUString& );
    };
}		//	namespace framework

#endif
