
package org.netbeans.modules.openoffice;

import org.openide.compiler.ExternalCompiler;
import org.openide.execution.NbProcessDescriptor;
import org.openide.filesystems.FileObject;

/**
 *
 * @author  Michael Bohn
 *
 */

public class OOURDCompiler extends ExternalCompiler {

        
    public OOURDCompiler (FileObject fo, NbProcessDescriptor proc, ExternalCompiler.ErrorExpression err) {
        // Always treat as Build cookie, since the target actually decides all this:
        super (fo, BUILD, proc, err);
        
    }
    
   public OOURDCompiler ( String resourceName,  Object type, NbProcessDescriptor nbDescriptor, ExternalCompiler.ErrorExpression err)
    {
        super ( resourceName,  type, nbDescriptor, err);
        
    }
    
    
    /** Get the compiler group class to use.
     * @return the class
     */
    public Class compilerGroupClass () {
        return OOURDCompilerGroup.class;
    }

    /** Whether the compiler is up-to-date.
     * Could use make -q but why waste time? If it is up to date, make
     * will not rebuild it anyway, we do not need to care.
     * @return always <CODE>false</CODE>
     */
    public boolean isUpToDate () {
        return false;
    }

    /** One key per compiler.
     */
    private Object key = new Object ();
    /** Get the grouping key.
     * In this case, constant per compiler,
     * since these should never be grouped together.
     * @return the constant key
     */
    public Object compilerGroupKey () {
        // Note: do not use 'this' as that causes a cycle in equals()
        return key;
    }

    /** Test for compiler equality.
     * @param o compiler to test against
     * @return <CODE>true</CODE> if equivalent
     */
    public boolean equals (Object o) {
        if (! (o instanceof OOURDCompiler)) return false;
        if (! super.equals (o)) return false;
        return true;
    }

    /** Get the compiler hash code.
     * @return a computed hash
     */
    public int hashCode () {
        return super.hashCode ();
    }

}
