/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: objadj.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 23:50:48 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#pragma hdrstop

#include "objadj.hxx"
#include "glob.hxx"




/*************************************************************************
|*
|* Objekt-Ausrichting ermitteln
|*
\************************************************************************/

SchObjectAdjust* GetObjectAdjust(const SdrObject& rObj)
{
	for (USHORT i = 0; i < rObj.GetUserDataCount(); i++)
	{
		SdrObjUserData *pData = rObj.GetUserData(i);
		if (pData && pData->GetId() == SCH_OBJECTADJUST_ID)
			return (SchObjectAdjust*)pData;
	}

	return NULL;
}

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchObjectAdjust::SchObjectAdjust() :
	SdrObjUserData(SchInventor, SCH_OBJECTADJUST_ID, 1),
	eAdjust(CHADJUST_TOP_LEFT),
	eOrient(CHTXTORIENT_STANDARD)
{
}

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchObjectAdjust::SchObjectAdjust(ChartAdjust eAdj,
								 SvxChartTextOrient eOr) :
	SdrObjUserData(SchInventor, SCH_OBJECTADJUST_ID, 1),
	eAdjust(eAdj),
	eOrient(eOr)
{
}

/*************************************************************************
|*
|* Kopier-Konstruktor
|*
\************************************************************************/

SchObjectAdjust::SchObjectAdjust(const SchObjectAdjust& rObjectAdjust) :
	SdrObjUserData(rObjectAdjust),
	eAdjust(rObjectAdjust.eAdjust),
	eOrient(rObjectAdjust.eOrient)
{
}

/*************************************************************************
|*
|* Kopie erzeugen
|*
\************************************************************************/

SdrObjUserData* SchObjectAdjust::Clone(SdrObject *pObj) const
{
	return new SchObjectAdjust(*this);
}

/*************************************************************************
|*
|* Daten in Stream schreiben
|*
\************************************************************************/

//BFS01void SchObjectAdjust::WriteData(SvStream& rOut)
//BFS01{
//BFS01	SdrObjUserData::WriteData(rOut);
//BFS01
//BFS01	rOut << (INT16)eAdjust;
//BFS01	rOut << (INT16)eOrient;
//BFS01}

/*************************************************************************
|*
|* Daten aus Stream lesen
|*
\************************************************************************/

//BFS01void SchObjectAdjust::ReadData(SvStream& rIn)
//BFS01{
//BFS01	SdrObjUserData::ReadData(rIn);
//BFS01
//BFS01	INT16 nInt16;
//BFS01
//BFS01	rIn >> nInt16; eAdjust = (ChartAdjust)nInt16;
//BFS01
//BFS01	if (nVersion < 1)
//BFS01		eOrient = CHTXTORIENT_STANDARD;
//BFS01	else
//BFS01	{
//BFS01		rIn >> nInt16; eOrient = (SvxChartTextOrient)nInt16;
//BFS01	}
//BFS01
//BFS01}



