/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: filenotation.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 21:04:59 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVX_FILENOTATION_HXX_
#define _SVX_FILENOTATION_HXX_

#include <rtl/ustring.hxx>

//.........................................................................
namespace svx
{
//.........................................................................

	//=====================================================================
	//= OFileNotation
	//=====================================================================
	class OFileNotation
	{
	protected:
		::rtl::OUString		m_sSystem;
		::rtl::OUString		m_sFileURL;

	public:
		enum NOTATION
		{
			N_SYSTEM,
			N_URL,
			N_DETECT
		};

		// ctor
		OFileNotation( const ::rtl::OUString& _rFileOrPath );

		/** ctor
		@deprecated
		*/
		OFileNotation(const ::rtl::OUString& _rFileOrPath, NOTATION _eInputNotation);

		/// E_DETECT not allowed here ...
		::rtl::OUString get(NOTATION _eOutputNotation);

	private:
		void	construct( const ::rtl::OUString& _rFileOrPath );
	};

//.........................................................................
}	// namespace svx
//.........................................................................

#endif // _SVX_FILENOTATION_HXX_

