/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svuidlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 22:06:29 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#include "svuidlg.hrc"
#include "svuidlg.hxx"

// class MdUpdateBaselinks -----------------------------------------------

MdUpdateBaselinks::MdUpdateBaselinks( Window * pParent, const ResId & rResId, BOOL bFreeRes )
    : ModalDialog( pParent, rResId ),
    aFtFiles( this, ResId( FT_FILES ) ),
    aFtLinks( this, ResId( FT_LINKS ) ),
    aFtType( this, ResId( FT_TYPE ) ),
    aFtStatus( this, ResId( FT_STATUS ) ),
    aCancelButton1( this, ResId( 1 ) ),
    aHelpButton1( this, ResId( 1 ) ),
    aPbUpdateNow( this, ResId( PB_UPDATE_NOW ) ),
    aPbOpenSource( this, ResId( PB_OPEN_SOURCE ) ),
    aPbChangeSource( this, ResId( PB_CHANGE_SOURCE ) ),
    aPbBreakLink( this, ResId( PB_BREAK_LINK ) ),
    aFtFiles2( this, ResId( FT_FILES2 ) ),
    aFtSource2( this, ResId( FT_SOURCE2 ) ),
    aFtType2( this, ResId( FT_TYPE2 ) ),
    aFtUpdate( this, ResId( FT_UPDATE ) ),
    aRbAutomatic( this, ResId( RB_AUTOMATIC ) ),
    aRbManual( this, ResId( RB_MANUAL ) ),
    aFtFullFileName( this, ResId( FT_FULL_FILE_NAME ) ),
    aFtFullSourceName( this, ResId( FT_FULL_SOURCE_NAME ) ),
    aFtFullTypeName( this, ResId( FT_FULL_TYPE_NAME ) ),
    aStrAutolink( ResId( STR_AUTOLINK ) ),
    aStrManuallink( ResId( STR_MANUALLINK ) ),
    aStrBrokenlink( ResId( STR_BROKENLINK ) ),
    aStrGraphiclink( ResId( STR_GRAPHICLINK ) ),
    aStrButtonclose( ResId( STR_BUTTONCLOSE ) ),
    aStrCloselinkmsg( ResId( STR_CLOSELINKMSG ) ),
    aStrCloselinkmsgMulti( ResId( STR_CLOSELINKMSG_MULTI ) ),
    aStrWaitinglink( ResId( STR_WAITINGLINK ) )
{
    if( bFreeRes ) FreeResource();
}

// class MdLinkedit ------------------------------------------------------

MdLinkedit::MdLinkedit( Window * pParent, const ResId & rResId, BOOL bFreeRes )
    : ModalDialog( pParent, rResId ),
    aOKButton1( this, ResId( 1 ) ),
    aCancelButton1( this, ResId( 1 ) ),
    aFtFullTypeName( this, ResId( FT_FULL_TYPE_NAME ) ),
    aFixedText2( this, ResId( 2 ) ),
    aEdFullSourceName( this, ResId( ED_FULL_SOURCE_NAME ) )
{
    if( bFreeRes ) FreeResource();
}

