/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: siimport.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 23:02:41 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVX_SIIMPORT_HXX
#include "siimport.hxx"
#endif

//BFS01#ifndef _SVDORECT_HXX
//BFS01#include "svdorect.hxx"
//BFS01#endif
//BFS01
//BFS01#ifndef _SVDIO_HXX
//BFS01#include "svdio.hxx"
//BFS01#endif
//BFS01
//BFS01#ifndef _SVDMODEL_HXX
//BFS01#include "svdmodel.hxx"
//BFS01#endif
//BFS01
//BFS01#ifndef _SVX_XFLCLIT_HXX
//BFS01#include "xflclit.hxx"
//BFS01#endif
//BFS01
//BFS01#ifndef _SVX_XLNCLIT_HXX
//BFS01#include "xlnclit.hxx"
//BFS01#endif
//BFS01
//BFS01#ifndef _XTABLE_HXX
//BFS01#include "xtable.hxx"
//BFS01#endif


//============================================================================
// defines
//============================================================================

//BFS01const UINT32 SiInventor = UINT32('S')*0x00000001+
//BFS01						  UINT32('D')*0x00000100+
//BFS01						  UINT32('V')*0x00010000+
//BFS01						  UINT32('C')*0x01000000;

//BFS01#define OBJ_CHECKBOX  			((UINT16)0)
//BFS01#define OBJ_RADIOBUTTON         ((UINT16)1)
//BFS01#define OBJ_PUSHBUTTON          ((UINT16)2)
//BFS01#define OBJ_SPINBUTTON          ((UINT16)3)
//BFS01#define OBJ_FIXEDTEXT           ((UINT16)4)
//BFS01#define OBJ_GROUPBOX            ((UINT16)5)
//BFS01#define OBJ_LISTBOX             ((UINT16)6)
//BFS01#define OBJ_COMBOBOX            ((UINT16)7)
//BFS01#define OBJ_EDIT                ((UINT16)8)
//BFS01#define OBJ_HSCROLLBAR          ((UINT16)9)
//BFS01#define OBJ_VSCROLLBAR          ((UINT16)10)

//BFS01#define OBJ_URLBUTTON           ((UINT16)25)

//BFS01static BOOL bInit = FALSE;

//============================================================================
// SiImportRect
//============================================================================

//BFS01class SiImportRect : public SdrRectObj
//BFS01{
//BFS01public:
//BFS01	SiImportRect();
//BFS01
//BFS01	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);
//BFS01};

//----------------------------------------------------------------------------

//BFS01SiImportRect::SiImportRect() : SdrRectObj()
//BFS01{
//BFS01}

//----------------------------------------------------------------------------

//BFS01void SiImportRect::ReadData(const SdrObjIOHeader& rHead, SvStream& rIn)
//BFS01{
//BFS01	// SdrRectObj ueberspringen!!!!
//BFS01	SdrObject::ReadData( rHead, rIn );
//BFS01	SdrDownCompat aCompat( rIn, STREAM_READ );
//BFS01	aRect = aOutRect;
//BFS01	SfxItemSet aSet(pModel->GetItemPool());
//BFS01	aSet.Put(XFillStyleItem(XFILL_SOLID));
//BFS01	aSet.Put(XFillColorItem(String(), RGB_Color(COL_LIGHTRED)));
//BFS01	aSet.Put(XLineStyleItem(XLINE_SOLID));
//BFS01	aSet.Put(XLineColorItem(String(), RGB_Color(COL_BLACK)));
//BFS01
//BFS01    SetObjectItemSet(aSet);
//BFS01
//BFS01	SetXPolyDirty();
//BFS01}


//============================================================================
// SiImportFactory
//============================================================================

//BFS01SiImportFactory::SiImportFactory()
//BFS01{
//BFS01	if ( !bInit )
//BFS01	{
//BFS01		SdrObjFactory::InsertMakeObjectHdl( LINK(this, SiImportFactory, MakeObject) );
//BFS01		bInit = TRUE;
//BFS01	}
//BFS01}

//----------------------------------------------------------------------------

//BFS01SiImportFactory::~SiImportFactory()
//BFS01{
//BFS01}

//----------------------------------------------------------------------------

//BFS01IMPL_LINK( SiImportFactory, MakeObject, SdrObjFactory *, pObjFactory )
//BFS01{
//BFS01	if( pObjFactory->nInventor == SiInventor )
//BFS01	{
//BFS01		if( ((pObjFactory->nIdentifier >= OBJ_CHECKBOX) && (pObjFactory->nIdentifier <= OBJ_VSCROLLBAR)) ||
//BFS01			pObjFactory->nIdentifier == OBJ_URLBUTTON )
//BFS01		{
//BFS01            switch( pObjFactory->nIdentifier )
//BFS01			{
//BFS01				case OBJ_CHECKBOX:
//BFS01				case OBJ_RADIOBUTTON:
//BFS01				case OBJ_PUSHBUTTON:
//BFS01				case OBJ_SPINBUTTON:
//BFS01				case OBJ_FIXEDTEXT:
//BFS01				case OBJ_GROUPBOX:
//BFS01				case OBJ_LISTBOX:
//BFS01				case OBJ_COMBOBOX:
//BFS01				case OBJ_EDIT:
//BFS01				case OBJ_HSCROLLBAR:
//BFS01				case OBJ_VSCROLLBAR:
//BFS01				case OBJ_URLBUTTON:
//BFS01					pObjFactory->pNewObj = new SiImportRect();
//BFS01			}
//BFS01        }
//BFS01	}
//BFS01
//BFS01	return 0;
//BFS01}

//----------------------------------------------------------------------------



