#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.28 $
#
#   last change: $Author: rt $ $Date: 2005/09/09 16:18:54 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

PRJ=..

PRJNAME=ucb
TARGET=unotypes
AUTOSEG=true

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk


UNOTYPES=\
	com.sun.star.beans.PropertyAttribute \
	com.sun.star.beans.PropertySetInfoChange \
	com.sun.star.beans.XPropertiesChangeNotifier \
	com.sun.star.beans.XPropertyAccess \
	com.sun.star.beans.XPropertyContainer \
	com.sun.star.beans.XPropertySetInfoChangeNotifier \
	com.sun.star.bridge.XUnoUrlResolver \
	com.sun.star.container.XChild \
	com.sun.star.container.XEnumerationAccess \
	com.sun.star.container.XHierarchicalNameAccess \
    com.sun.star.container.XIndexAccess \
	com.sun.star.container.XNameContainer \
	com.sun.star.container.XNamed \
    com.sun.star.document.XStorageBasedDocument \
    com.sun.star.document.XEventBroadcaster \
    com.sun.star.document.XEventListener \
    com.sun.star.embed.ElementModes \
    com.sun.star.embed.XStorage \
    com.sun.star.embed.XTransactedObject \
    com.sun.star.frame.XController \
	com.sun.star.frame.XConfigManager \
    com.sun.star.frame.XModel \
    com.sun.star.frame.XTransientDocumentsDocumentContentFactory \
	com.sun.star.io.XActiveDataSink \
	com.sun.star.io.XActiveDataStreamer \
	com.sun.star.io.XOutputStream \
	com.sun.star.io.XSeekable \
	com.sun.star.io.XStream \
    com.sun.star.io.XTruncate \
	com.sun.star.lang.DisposedException \
    com.sun.star.lang.IllegalAccessException \
	com.sun.star.lang.IllegalArgumentException \
	com.sun.star.lang.XInitialization \
	com.sun.star.lang.XServiceInfo \
	com.sun.star.lang.XSingleServiceFactory \
	com.sun.star.lang.XMultiServiceFactory \
	com.sun.star.lang.XTypeProvider \
    com.sun.star.reflection.XProxyFactory \
	com.sun.star.registry.XRegistryKey \
	com.sun.star.script.XTypeConverter \
	com.sun.star.sdbc.DataType \
	com.sun.star.sdbc.FetchDirection \
	com.sun.star.sdbc.ResultSetType \
	com.sun.star.sdbc.XCloseable \
	com.sun.star.sdbc.XColumnLocate \
	com.sun.star.sdbc.XResultSetMetaDataSupplier \
	com.sun.star.sdbc.XRow \
    com.sun.star.task.DocumentPasswordRequest \
    com.sun.star.task.XInteractionPassword \
	com.sun.star.task.XInteractionAbort \
	com.sun.star.task.XInteractionRetry \
	com.sun.star.ucb.AuthenticationRequest \
	com.sun.star.ucb.CHAOSProgressStart \
    com.sun.star.ucb.CommandFailedException \
	com.sun.star.ucb.ContentAction \
	com.sun.star.ucb.ContentCreationException \
	com.sun.star.ucb.ContentInfoAttribute \
	com.sun.star.ucb.ContentResultSetCapability \
	com.sun.star.ucb.CrossReference \
	com.sun.star.ucb.DocumentHeaderField \
	com.sun.star.ucb.FetchError \
	com.sun.star.ucb.FileSystemNotation \
	com.sun.star.ucb.GlobalTransferCommandArgument \
    com.sun.star.ucb.IllegalIdentifierException \
	com.sun.star.ucb.InsertCommandArgument \
    com.sun.star.ucb.InteractiveAugmentedIOException \
	com.sun.star.ucb.InteractiveBadTransferURLException \
    com.sun.star.ucb.InteractiveNetworkConnectException \
    com.sun.star.ucb.InteractiveNetworkGeneralException \
    com.sun.star.ucb.InteractiveNetworkReadException \
    com.sun.star.ucb.InteractiveNetworkResolveNameException \
    com.sun.star.ucb.InteractiveNetworkWriteException \
	com.sun.star.ucb.Link \
	com.sun.star.ucb.ListActionType \
	com.sun.star.ucb.Lock \
    com.sun.star.ucb.MissingInputStreamException \
    com.sun.star.ucb.MissingPropertiesException \
	com.sun.star.ucb.NameClash \
    com.sun.star.ucb.NameClashException \
	com.sun.star.ucb.OpenCommandArgument2 \
	com.sun.star.ucb.OpenMode \
    com.sun.star.ucb.PostCommandArgument2 \
	com.sun.star.ucb.RecipientInfo \
	com.sun.star.ucb.RememberAuthentication \
	com.sun.star.ucb.ResultSetException \
	com.sun.star.ucb.RuleOperator \
	com.sun.star.ucb.RuleSet \
	com.sun.star.ucb.SearchCommandArgument \
	com.sun.star.ucb.SendInfo \
	com.sun.star.ucb.SendMediaTypes \
	com.sun.star.ucb.TransferInfo \
    com.sun.star.ucb.UnsupportedCommandException \
    com.sun.star.ucb.UnsupportedDataSinkException \
    com.sun.star.ucb.UnsupportedNameClashException \
    com.sun.star.ucb.UnsupportedOpenModeException \
	com.sun.star.ucb.WelcomeDynamicResultSetStruct \
	com.sun.star.ucb.XCachedContentResultSetFactory \
	com.sun.star.ucb.XCachedContentResultSetStubFactory \
	com.sun.star.ucb.XCachedDynamicResultSetFactory \
	com.sun.star.ucb.XCachedDynamicResultSetStubFactory \
	com.sun.star.ucb.XCommandInfo \
	com.sun.star.ucb.XCommandInfoChangeNotifier \
	com.sun.star.ucb.XCommandProcessor \
	com.sun.star.ucb.XContentAccess \
	com.sun.star.ucb.XContentCreator \
	com.sun.star.ucb.XContentIdentifierFactory \
	com.sun.star.ucb.XContentIdentifierMapping \
	com.sun.star.ucb.XContentProvider \
	com.sun.star.ucb.XContentProviderFactory \
	com.sun.star.ucb.XContentProviderManager \
	com.sun.star.ucb.XContentProviderSupplier \
	com.sun.star.ucb.XDataContainer \
	com.sun.star.ucb.XDynamicResultSet \
	com.sun.star.ucb.XFetchProvider \
	com.sun.star.ucb.XFetchProviderForContentAccess \
	com.sun.star.ucb.XInteractionSupplyAuthentication \
	com.sun.star.ucb.XFileIdentifierConverter \
	com.sun.star.ucb.XParameterizedContentProvider \
	com.sun.star.ucb.XPropertySetRegistryFactory \
	com.sun.star.ucb.XSortedDynamicResultSetFactory \
	com.sun.star.ucb.XSourceInitialization \
    com.sun.star.uno.RuntimeException \
	com.sun.star.uno.XAggregation \
    com.sun.star.uno.XComponentContext \
	com.sun.star.uno.XWeak \
	com.sun.star.util.XChangesBatch \
	com.sun.star.util.XChangesListener \
    com.sun.star.util.XChangesNotifier \
    com.sun.star.util.XOfficeInstallationDirectories

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk

