package com.sun.star.wizards.tutorial.creator.frame.objectFinder;

import com.sun.star.accessibility.XAccessibleContext;

/**
 * This interface defines two methods for setting and refreshing of the representation of
 * the found staroffice object.
 */
interface IAccessibleObjectDisplay {
    /**
     * Set the accessible object to display.  Call this method e.g. when a new object has
     * been focused.
     *
     * @param Accessible object context
     */
    public void setAccessibleObject(XAccessibleContext xContext);

    /**
     * Update GUI
     *
     * @param Accessible object context
     */
    public void updateAccessibleObject(XAccessibleContext xContext);
}
